/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * AUTHOR: Angelo Rosiello
 * CONTACT: angelo@rosiello.org, rosiello.angelo@virgilio.it, angelo@dtors.net
 */


#include "search.h"

char *search(char *distro)
{
	//REQUIRES: distro != NULL
	//EFFECTS : returns the right url
	char *url = (char *)malloc(1024);
	char version[10], distribution[20];
	char *redhat = "Red";
	char *mandrake = "Mandrake";
	char *fedora = "Fedora";
	int i, j, k;
	int stop = 0;

	for (i = 0; i < 1024; i++) url[i] = '\0'; // Initialize
	for (i = 0; i < 10; i++) version[i] = '\0';
	for (i = 0; i <20 ; i++) distribution[i] = '\0';

	i = 0; j = 0; k = 0;

	while(!stop)
	{
		if(distro[i] != '1' && distro[i] != '2' && distro[i] != '3'
		   && distro[i] != '4' && distro[i] != '5' && distro[i] !=  '6'
		   && distro[i] != '7' && distro[i] != '8' && distro[i] !=  '9'
		   && distro[i] != '0' && distro[i] != '.')
		{
			distribution[k] = distro[i];
			k++;
		}

		if(distro[i] == '1' || distro[i] == '2' || distro[i] == '3'
		   || distro[i] == '4' || distro[i] == '5' || distro[i] == '6'
		   || distro[i] == '7' || distro[i] == '8' || distro[i] == '9'
		   || distro[i] == '0' || distro[i] == '.')
		{
		   	version[j] = distro[i];
			j++;
		}
		if(distro[i] == '\0') stop = 1;
		i++;

	}

	if(!strcmp(distribution, redhat))
	{
		sprintf(url, "/linux/redhat/%s/en/os/i386/RedHat/RPMS/", version);
	}
	else if(!strcmp(distribution, mandrake))
	{
		sprintf(url, "/linux/Mandrake/updates/%s/RPMS/", version);
	}
	else if(!strcmp(distribution, fedora))
	{
		sprintf(url, "/linux/fedora/core/%s/i386/os/Fedora/RPMS/", version);
	}

	return(url);
}
